Revit API develop Test 1

  • Revit二次开发30/07/2020

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Autodesk.Revit.UI;
using Autodesk.Revit.Attributes;
using Autodesk.Revit.DB;
using Autodesk.Revit.UI.Selection;
using Autodesk.Revit.DB.Structure;

namespace loadF
{
[Transaction(TransactionMode.Manual)]
public class Class1 : IExternalCommand
{
public Result Execute(ExternalCommandData commandData, ref string message, ElementSet elements)
{
UIDocument uidoc = commandData.Application.ActiveUIDocument;
Document doc = uidoc.Document;

        Reference r = uidoc.Selection.PickObject(ObjectType.Element);
        Element ele = doc.GetElement(r);
        XYZ loc = (ele.Location as LocationPoint).Point;
        Transaction tx = new Transaction(doc, "delete element");
        tx.Start();
        doc.Delete(ele.Id);



        Family family = null;
        string path = @"F:\新建文件夹 (2)\欧式窗套窗.rfa";

        doc.LoadFamily(path, out family);

        

        FamilySymbol fs = doc.GetElement(family.GetFamilySymbolIds().First()) as FamilySymbol;

        if (!fs.IsActive)
        {
            fs.Activate();
        }

        Reference e = uidoc.Selection.PickObject(ObjectType.Face,"please pick a face on wall");
        Wall host_wall = doc.GetElement(e) as Wall;


        FilteredElementCollector col = new FilteredElementCollector(doc);
        col.OfCategory(BuiltInCategory.OST_Levels).Where(m => m.Name == "Level 1");
        Level lv = col.LastOrDefault<Element>() as Level;




        doc.Create.NewFamilyInstance(loc, fs, host_wall,lv, StructuralType.NonStructural);






        tx.Commit();
        return Result.Succeeded;


    }
}

}

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值